<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class ItempindahstokValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		if(empty($input["penyesuaianBarangId"])){
			array_push($this->error, ["penyesuaianBarangId" => "cannot be null"]);
		}
		else{
			$lengthpenyesuaianbarangid = strlen($input["penyesuaianBarangId"]);
			if($lengthpenyesuaianbarangid>19){
			array_push($this->error, ["penyesuaianbarangid" => "value too long"]);
			}
		}
		$pindahstok= (new \App\Http\Models\PindahstokkapalModel())
			->getQuery()->where("id","=",$input["penyesuaianBarangId"])->first();
		if(empty($pindahstok)){
			array_push($this->error, ["penyesuaianBarangId" => "invalid relation"]);
		}
		if(empty($input["quantity"])){
			array_push($this->error, ["quantity" => "cannot be null"]);
		}
		else{
			$lengthquantity = strlen($input["quantity"]);
			if($lengthquantity>10){
			array_push($this->error, ["quantity" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["itemId"])){
			array_push($this->error, ["itemId" => "cannot be null"]);
		}
		else{
			$lengthitemid = strlen($input["itemId"]);
			if($lengthitemid>19){
			array_push($this->error, ["itemid" => "value too long"]);
			}
		}
		if(!empty($input["itemId"])){
		$item= (new \App\Http\Models\ItemModel())
			->getQuery()->where("id","=",$input["itemId"])->first();
		if(empty($item)){
			array_push($this->error, ["itemId" => "invalid relation"]);
		}
		}
		if(empty($input["penyesuaianBarangId"])){
			array_push($this->error, ["penyesuaianBarangId" => "cannot be null"]);
		}
		else{
			$lengthpenyesuaianbarangid = strlen($input["penyesuaianBarangId"]);
			if($lengthpenyesuaianbarangid>19){
			array_push($this->error, ["penyesuaianbarangid" => "value too long"]);
			}
		}
		if(!empty($input["penyesuaianBarangId"])){
		$pindahstok= (new \App\Http\Models\PindahstokkapalModel())
			->getQuery()->where("id","=",$input["penyesuaianBarangId"])->first();
		if(empty($pindahstok)){
			array_push($this->error, ["penyesuaianBarangId" => "invalid relation"]);
		}
		}
		if(empty($input["quantity"])){
			array_push($this->error, ["quantity" => "cannot be null"]);
		}
		else{
			$lengthquantity = strlen($input["quantity"]);
			if($lengthquantity>10){
			array_push($this->error, ["quantity" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}